//************************************************************************
// Datei: readbmp.c
//
// Liest eine Bitmap von einer Speicherkarte und schreibt sie in den
// Grafikschirm eines Displays.
//
// Dieses Programm wird mit hoher Wahrscheinlichkeit nicht alle Bitmaps
// lesen knnen die mit diversen Grafikprogrammen erzeugt wurden. Ich erwarte
// dann eine fehlerhafte Darstellung auf dem Display.
//
// Die Bitmap darf nur SW sein. Farbige Bitmaps werden natrlich nicht geladen.
// Obwohl, das ist nicht richtig ;) Sie werden geladen, aber es ist dann Schrott
// auf dem Display.
//
// hk@holger-klabunde.de
// http://www.holger-klabunde.de
// 01.10.2010
// Compiler AVR-GCC 3.4.6
//************************************************************************
#include <avr/io.h>
#include <avr/pgmspace.h>


#include "param.h"
#include "fontsoftape.h"

//*****INCLUD-FILES FOR SD-CARD*********
#include "dos.h"			
#include "fat.h"			
#include "dosdefs.h"						
#include "mmc_spi.h"
#include "find_x.h"		
#include "savebmp.h"
//*****INCLUD-FILES FOR SD-CARD*********

#include "lcd.h"
#include "bitmap.h"

//#############################################################
// Display loading routine. 
// Returns 0 if failed, >0 if successfull
//
unsigned char LoadGraphDisplay(char *name, unsigned short baseadr)
//#############################################################
{
 unsigned char by, result, fillbytes;
 unsigned int x, y;
 struct bmpheader bmp;
 unsigned char bytes_per_row; 
 
 if(Fopen(name,F_READ)!=F_OK) return 0;

// Read the BMP header and
 result=Fread((unsigned char *)&bmp,sizeof(struct bmpheader));
 if(result != sizeof(struct bmpheader))
  {
   Fclose();
   return 0;
  }
 
 // Problem ! BMP's have to use 4 Byte boundarys.
 // So if you have 240 pixels and 8 pixel per byte, this is
 // 30 bytes per row. But it has to be 32 for Win !
 // For 240 pixels and 6 pixel per byte this is 40. OK.
 
 bytes_per_row = bmp.width / 8;
 if((bmp.width % 8) != 0) bytes_per_row++; // if there is a rest add a byte

 fillbytes = 4 - ( bytes_per_row % 4 ); //unused bytes at the end of a row of a bitmap
 
 // this is not complete. if you have a 9x8 bitmap this will draw 16x8
 
 for(y = bmp.height; y > 0 ; y--)
  {
   // BMP's want to be drawn from down to up !

   	for(x = 0; x < bytes_per_row; x++)
   	{
		Fread(&by,1);
		
		// check bmp.widht here and decide if we can write a whole byte or use setpixel?
		
    	lcd_writebyte(x,y,by,0);
	} //for x

   // read and skip the fillbytes at the end of a row
   for(x = 0; x < fillbytes; x++)
    {
     result=Fread(&by,1);
    } 

  }// for y

 Fclose();
 return result;
}











